#include <stdio.h>
#include <fstream.h>
#include <iostream.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <dos.h>
#include "mouse.h"
#include "kb.h"

#define ANGLE_0    0
#define ANGLE_90   480
#define ANGLE_180  960
#define ANGLE_270  1440
#define ANGLE_360  1920

#define CELL_SIZE     128
#define M             16384
#define N_DIGIT       22
#define M_DIGIT       14
#define INF           2147483647L
#define MAP_SIZE      32
#define TABLE_SIZE    1920
#define ANGLE_INC     0.1875

long tan_table[TABLE_SIZE];
long ctn_table[TABLE_SIZE];
long sin_table[TABLE_SIZE];
long cos_table[TABLE_SIZE];

void far *data1 = (void far *)new char[16384];
void far *data2 = (void far *)new char[16384];
void far *data3 = (void far *)new char[40960];
void far *buffer = (void far *)new char[64000];
unsigned char map[32][32];
unsigned char pal[1024];
float cos1_table[320];
int tex_off, tex_flag, exit_flag = 0, map_flag = 0;
int l, r, f, b, m_b, m_x, m_a, speed, s_inc = 1;
int r_strafe, l_strafe;
char tex1[14] = "058-013.bmp";
char tex2[14] = "059-013.bmp";

ofstream out;
ifstream in;

void interrupt (*old_vec)(...);

long dist(int angle, long player_x, long player_y)
{
  long x = player_x << M_DIGIT, y = player_y << M_DIGIT;
  long xx = x, yy = y;
  long xp = x, yp = y, N = CELL_SIZE * M, xp1 = x, yp1 = y;
  long x_dist, y_dist, INC, A = 0;
  long MAP_SIZE_N = MAP_SIZE * CELL_SIZE * M;

  if (angle < 0) angle = 1920 - (-angle) % 1920;
  if (angle > 1920) angle %= 1920;

  if ((angle != ANGLE_0) && (angle != ANGLE_180))
  {
    if ((angle > ANGLE_0) && (angle < ANGLE_180))
    {
      yp = y % N;
      xp += (yp >> M_DIGIT) * ctn_table[angle];
      yp = y - yp;
      INC = -N;
      A = -1;
    }
    else
    {
      yp = N - (y % N);
      xp -= (yp >> M_DIGIT) * ctn_table[angle];
      yp += y;
      INC = N;
      A = 0;
    }
    while(!map[(yp >> N_DIGIT) + A][xp >> N_DIGIT] && (xp > 0) && (xp < MAP_SIZE_N))
    {
      yp += INC;
      xp -= (INC >> M_DIGIT) * ctn_table[angle];
    }
    xp >>= M_DIGIT;
    yp >>= M_DIGIT;
    x_dist = (long)sqrt((xp - xx) * (xp - xx) + (yp - yy) * (yp - yy));
  }
  else x_dist = INF;

  if ((angle != ANGLE_90) && (angle != ANGLE_270))
  {
    if ((angle > ANGLE_90) && (angle < ANGLE_270))
    {
      xp1 = x % N;
      yp1 += (xp1 >> M_DIGIT) * tan_table[angle];
      xp1 = x - xp1;
      INC = -N;
      A = -1;
    }
    else
    {
      xp1 = N - (x % N);
      yp1 -= (xp1 >> M_DIGIT) * tan_table[angle];
      xp1 += x;
      INC = N;
      A = 0;
    }
    while(!map[yp1 >> N_DIGIT][(xp1 >> N_DIGIT) + A] && (yp1 > 0) && (yp1 < MAP_SIZE_N))
    {
      xp1 += INC;
      yp1 -= (INC >> M_DIGIT) * tan_table[angle];
    }
    xp1 >>= M_DIGIT;
    yp1 >>= M_DIGIT;
    y_dist = (long)sqrt((xp1 - xx) * (xp1 - xx) + (yp1 - yy) * (yp1 - yy));
  }
  else y_dist = INF;

  return (x_dist < y_dist) ? x_dist : y_dist;
}

void fill_tables()
{
  for (int i = 0; i < TABLE_SIZE; i++)
  {
    sin_table[i] = (long)(M * sin(i * ANGLE_INC * M_PI / 180));
    cos_table[i] = (long)(M * cos(i * ANGLE_INC * M_PI / 180));
    if (cos_table[i])
      tan_table[i] = (long)(M * tan(i * ANGLE_INC * M_PI / 180));
    else
      tan_table[i] = INF;
    if (sin_table[i])
      ctn_table[i] = (long)(M / tan(i * ANGLE_INC * M_PI / 180));
    else
      ctn_table[i] = INF;
  }

  for (int i = 0; i < 320; i++)
    cos1_table[i] = cos((i * 0.1875 - 30) * M_PI / 180);
}

void interrupt KB_HANDLER(...)
{
  unsigned char key = inportb(0x60);

  if (key == 15) map_flag = 1;
  if (key == 143) map_flag = 0;

  if (!map_flag)
  switch (key)
  {
    case  1:  exit_flag = 1; break;
    case 80:  b = 1; f = 0; break;
    case 72:  f = 1; b = 0; break;
    case 77:  r = 1; l = 0; break;
    case 75:  l = 1; r = 0; break;
    case 208: b = 0; f = 0; break;
    case 200: f = 0; b = 0; break;
    case 205: r = 0; l = 0; break;
    case 203: l = 0; r = 0; break;
    case  57:08C3 speed = 0; break;
    case  42: s_inc = 2; break;
    case 170: s_inc = 1; break;
    case  51: l_strafe = 1; r_strafe = 0; break;
    case 179: l_strafe = 0; break;
    case  52: r_strafe = 1; l_strafe = 0; break;
    case 180: r_strafe = 0; break;
  }

  old_vec();
}

void vert_ret()
{
  asm
  {
    cli
    mov dx, 03DAh
@1: in al, dx
    test al, 8
    jz @1
@2: in al, dx
    test al, 8
    jnz @2
    sti
  }
}

void set_mode(unsigned int mode)
{
  asm
  {
      mov    ax,  mode
      int    10h
  }
}

void set_rgb(unsigned char n, unsigned char r, unsigned char g, unsigned char b)
{
  asm
  {
      mov    dx,  3C8h
      mov    al,  n
      out    dx,  al
      inc    dx
      mov    al,  r
      shr    al,  2
      out    dx,  al
      mov    al,  g
      shr    al,  2
      out    dx,  al
      mov    al,  b
      shr    al,  2
      out    dx,  al
  }
}

void set_pal()
{
  for (int i = 1; i < 256; i++)
    set_rgb(i, pal[i * 4 + 2], pal[i * 4 + 1], pal[i * 4]);
}

void put_sky(int offs)
{
  asm
  {
      push   ds
      push   es
      lds    si,  data3
      les    di,  buffer
      xor    di,  di
      mov    cx,  40960
      rep    movsb
      pop    es
      pop    ds
  }
}

void put_buf()
{
  asm
  {
      push   ds
      lds    si,  buffer
      mov    ax,  0A000h
      mov    es,  ax
      xor    di,  di
      mov    cx,  64000
      rep    movsb
      pop    ds
  }
}

void put_line(int x, int from, int to, unsigned char c1, int off, int m)
{
  char c = 128;
  asm
  {
      push   ds
      cmp    tex_flag,   0
      jz     @@4
      lds    si,  data1
      jmp    @@5
@@4:  lds    si,  data2
@@5:
//      les    di,  buffer
      mov    ax,  0A000h
      mov    es,  ax

      mov    di,  x
      mov    cx,  200
@1:   mov    al,  c
      shr    al,  3
      add    al,  c1

//      mov    ax,  200
//      sub    ax,  cx
//      mov    bx,  ax
//      shl    ax,  8
//      shl    bx,  6
//      add    ax,  bx
//      add    ax,  x
//      mov    ax,  x
//      push   es
//      push   di
//      les    di,  data3
//      mov    di,  ax
//      mov    al,  es:[di]
//      pop    di
//      pop    es

      cmp    cx,  from
      jb     @2
      cmp    cx,  to
      ja     @2
      xor    dx,  dx
      mov    ax,  32256
      mov    bx,  m
      div    bx
      mov    bx,  200
      sub    bx,  cx
      cmp    from,  0
      jnz    @@3
      push   cx
      mov    cx,  m
      sub    cx,  200
      shr    cx,  1
      add    bx,  cx
      pop    cx
@@3:  sub    bx,  from
      mul    bx
      shr    ax,  8
      shl    ax,  7
      add    ax,  off
      add    ax,  4
      mov    si,  ax
      mov    al,  ds:[si]
@2:   stosb
      add    di,  319
      cmp    c,   0
      jz     @@7
      dec    c
@@7:  loop   @1
      pop    ds
  }
}

void bar(int x, int y, int w, int h, char color)
{
  asm
  {
      mov    ax,  0A000h
      mov    es,  ax
      mov    di,  y
      shl    di,  8
      mov    bx,  y
      shl    bx,  6
      add    di,  bx
      add    di,  x
      mov    al,  color
      mov    cx,  h
@@1:  push   cx
      mov    cx,  w
      rep    stosb
      sub    di,  w
      add    di,  320
      pop    cx
      loop   @@1
  }
}

void draw_map(int x, int y)
{
  for (int i = 0; i < 32; i++)
    for (int j = 0; j < 32; j++)
      if (map[i][j] > 0)
        bar(i * 4 + 96, j * 3 + 52, 4, 3, 16);
  bar(x / 128 * 4 + 96, y / 128 * 3 + 52, 4, 3, 242);
}

void load()
{
  int i = 0, j = 0;
  char c;

  FILE *in = fopen(tex1, "rb");
  if (!in) throw "Unable to load texture\n";
  fseek(in, 54, 0);
  fread(pal, 1024, 1, in);
  fread((unsigned char *)data1, 16384, 1, in);
  fclose(in);
  in = fopen(tex2, "rb");
  if (!in) throw "Unable to load texture\n";
  fseek(in, 1078, 0);
  fread((unsigned char *)data2, 16384, 1, in);
  fclose(in);
  in = fopen("sky.bmp", "rb");
  if (!in) throw "Unable to load texture\n";
  fseek(in, 1078, 0);
  fread((unsigned char *)data3, 40960, 1, in);
  fclose(in);
  in = fopen("map.txt", "rt");
  if (!in) throw "Unable to load map\n";

  do
  {
    c = getc(in);
    switch (c)
    {
      case '*': map[i][j] = 1; i++; break;
      case ' ': map[i][j] = 0; i++; break;
      case 10: j++; i = 0;
    }
  }
  while (j < 32);

  fclose(in);
}

void print_help()
{
  cout << "\n3D World. Version 1.5.\n";
  cout << "Copyright (c) 1999 by MATI Inc.\n\n";
  cout << "\t Usage: 3DWORLD [options <files>]\n\n";
  cout << "Options:\n";
  cout << "\t-r  Record demo to <filename>\n";
  cout << "\t-p  Play demo from <filename>\n";
  cout << "\t-t  Load two alternate textures\n";
}

void check_command_line(int argc, char *argv1, char *argv2, char *argv3)
{
  for (int i = 0; i < strlen(argv1); i++)
    argv1[i] = toupper(argv1[i]);
  for (int j = 0; j < strlen(argv2); j++)
    argv2[j] = toupper(argv2[j]);

  if (argc >= 2)
  {
    if (!strcmp(argv1, "-R"))
    {
      out.open(argv2);
      if (!out || argc < 3)
        throw "Unable to open demo file\n";
    }
    else
    if (!strcmp(argv1, "-P"))
    {
      in.open(argv2);
      if (!in || argc < 3)
        throw "Unable to open demo file\n";
    }
    else
    if (!strcmp(argv1, "-T"))
    {
      if (!in || argc < 4)
        throw "Unable to load texture\n";
      strcpy(tex1, argv2);
      strcpy(tex2, argv3);
    }
    else
    if (!strcmp(argv1, "-?"))
    {
      print_help();
      throw "";
    }
    else
      throw "Unknown command option.\nType \"-?\" for help.\n";;
  }
}

int main(int argc, char *argv[])
{
  unsigned char key;
  int xp = 2048, yp = 2048, tx, ty;
  int angle_p = 0, angle;
  int color, d, m, s_speed;

  try
  {
    check_command_line(argc, argv[1], argv[2], argv[3]);
  }
  catch (const char *message)
  {
    cout << message;
    return 0;
  }

  try
  {
    load();
  }
  catch (const char *error)
  {
    cout << error;
    return 1;
  }

  set_mode(0x13);
  set_pal();
  fill_tables();

  old_vec = getvect(0x09);
  setvect(0x09, KB_HANDLER);
  ReadMouseCount(m_a, m_x);

  do
  {
    tx = xp;
    ty = yp;

    MouseRead(m_b, m_b, m_b);

    if (!map_flag)
    {
      ReadMouseCount(m_a, m_x);

      angle_p += m_a / 4;
      dist(angle, xp, yp);
      d = 256;//dist(int(angle_p * 5.3333333), xp, yp);
      if (m_x > d) m_x = d - 10;
      if (fabs(m_x) / 6 > fabs(speed)) speed = m_x / 6;

      if (b) speed = 16;
      if (f || (m_b == 1)) speed = -16;
      if (l_strafe)
        s_speed = 16;
      if (r_strafe)
        s_speed = -16;
      if (r_strafe || l_strafe)
      {
        tx += int(sin((angle_p) * M_PI / 180) * s_speed * s_inc / 2);
        ty += int(cos((angle_p) * M_PI / 180) * s_speed * s_inc / 2);
      }

      tx += int(sin((angle_p - 90) * M_PI / 180) * speed * s_inc);
      ty += int(cos((angle_p - 90) * M_PI / 180) * speed * s_inc);
      if (speed < 0) speed++;
      if (speed > 0) speed--;

      if (r) angle_p += 2;
      if (l) angle_p -= 2;
      if (angle_p > 359) angle_p -= 360;
      if (angle_p < 0) angle_p += 360;
    }

    if ((tx % 128 > 64) && map[tx / 128 + 1][ty / 128])
      tx = tx / 128 * 128 + 64;
    else
    if ((tx % 128 < 64) && map[tx / 128 - 1][ty / 128])
      tx = tx / 128 * 128 + 64;
    if ((ty % 128 > 64) && map[tx / 128][ty / 128 + 1])
      ty = ty / 128 * 128 + 64;
    else
    if ((ty % 128 < 64) && map[tx / 128][ty / 128 - 1])
      ty = ty / 128 * 128 + 64;

    xp = tx;
    yp = ty;

    if ((in) && (!out))
    {
      in >> xp;
      in >> yp;
      in >> angle_p;
      if (!in)
      {
        in.close();
        in.open(argv[2]);
      }
    }

    if (map_flag)
      draw_map(xp, yp);
    else
//    put_sky(0);
    for (int i = 0; i < 320; i++)
    {
      angle = ((angle_p - 30) * 53 + i * 10) / 10;
      if (angle < 0) angle = angle + 1920;
      if (angle > 1920) angle -= 1920;
//      dist(angle, xp, yp);
      d = 256;//dist(angle, xp, yp);
      if (d)
      {
        m = 32768 / (d /* cos_table[i]*/);
        if (m > 200)
          put_line(i, 0, m, 199, tex_off, m);
        else
          put_line(i, 100 - m / 2, 100 + m / 2, 80, tex_off, m);
      }
    }

    if (out)
    {
      out << xp << " ";
      out << yp << " ";
      out << angle_p << "\n";
    }
//   put_buf();

    K_Reset();
  } while (!exit_flag);

  setvect(0x09, old_vec);

  set_mode(0x3);
  out.close();
  in.close();
  cout << "Copyright (c) 1999 by MATI Inc.\n";

  return 0;
