#include <fstream.h>
#include <graphics.h>
#include <conio.h>
#include <math.h>
#include "kb.h"

#define ANGLE_0    0
#define ANGLE_90   480
#define ANGLE_180  960
#define ANGLE_270  1440
#define ANGLE_360  1920

unsigned char map[32][32];
unsigned char pal[1024];
float tan_table[1920];
float cos_table[60];

int dist(int a, unsigned int x_p, unsigned int y_p)
{
  float x = x_p, y = y_p, m, x_dist, y_dist, x_ = x_p, y_ = y_p;

  if (a == ANGLE_0) a = ANGLE_0 + 1;
  if (a == ANGLE_90) a = ANGLE_90 + 1;
  if (a == ANGLE_180) a = ANGLE_180 + 1;
  if (a == ANGLE_270) a = ANGLE_270 + 1;

  if (a < ANGLE_90 || a > ANGLE_270)
  {
    m = 128 * tan_table[a];
    x = int(x / 128) * 128 + 128;
    y += (x_p - x) * tan_table[a];
    while ((!map[(int)x >> 7][(int)y >> 7]) && (y > 0) && (y < 4096) && (x < 4096))
    {
      x += 128;
      y -= m;
    }
  }
  else
  if (a > ANGLE_90 && a < ANGLE_270)
  {
    m = 128 * tan_table[a];
    x = int(x / 128) * 128;
    y += (x_p - x) * tan_table[a];
    while (!map[(int)(x - 128) >> 7][(int)y >> 7] && y > 0 && x > 0 && y < 4096)
    {
      x -= 128;
      y += m;
    }
  }
  x_dist = sqrt(pow(x - x_p, 2) + pow(y - y_p, 2));

  if (a > ANGLE_180 && a < ANGLE_360)
  {
    m = 128 / tan_table[a];
    y_ = int(y_ / 128) * 128 + 128;
    x_ += (y_p - y_) / tan_table[a];
    while ((!map[(int)x_ >> 7][(int)y_ >> 7]) && (x_ > 0) && (x_ < 4096) && (y_ < 4096))
    {
      y_ += 128;
      x_ -= m;
    }
  }
  else
  if (a < ANGLE_180 && a > ANGLE_0)
  {
    m = 128 / tan_table[a];
    y_ = int(y_ / 128) * 128;
    x_ += (y_p - y_) / tan_table[a];
    while (!map[(int)x_ >> 7][(int)(y_ - 128) >> 7] && x_ > 0 && y_ > 0 && x_ < 4096)
    {
      y_ -= 128;
      x_ += m;
    }
  }
  y_dist = sqrt(pow(x_ - x_p, 2) + pow(y_ - y_p, 2));

  setcolor(14);
  if (x_dist < y_dist && x_dist != 0)
  {
    line(x_p * 14 / 128.0, y_p * 14 / 128.0, x * 14 / 128.0, y * 14 / 128.0);
    return x_dist;
  }
  if (y_dist < x_dist && y_dist != 0)
  {
    line(x_p * 14 / 128.0, y_p * 14 / 128.0, x_ * 14 / 128.0, y_ * 14 / 128.0);
    return y_dist;
  }

  return 0;
}

void fill_tables()
{
  float angle = 0;
  for (int i = 0; i < 1920; i++)
  {
    if (angle != ANGLE_90 && angle != ANGLE_270)
      tan_table[i] = sin(angle * M_PI / 180) / cos(angle * M_PI / 180);
    angle += 0.1875;
  }

  for (int i = 0; i < 60; i++)
    cos_table[i] = cos((i - 30) * M_PI / 180);
}

void load()
{
  ifstream in;
  int i = 0, j = 0;
  char c;

  in.open("map.txt");

  do
  {
    in.get(c);
    switch (c)
    {
      case '*': map[i][j] = 1; i++; break;
      case ' ': map[i][j] = 0; i++; break;
      case 10: j++; i = 0;
    }
  }
  while (j < 32);

  in.close();
}

int main()
{
  char key;
  float xp = 2048, yp = 2048, tx, ty;
  float angle_p = 0, angle;
  int gm, gd = DETECT;

  load();
  initgraph(&gd, &gm, "c:\\lng\\bc5\\bgi");
  fill_tables();

  setcolor(8);
  for (int i = 0; i < 33; i++)
  {
    line(i * 14, 0, i * 14, 448);
    line(0, i * 14, 448, i * 14);
  }

  setfillstyle(1, 7);
  for (int i = 0; i < 32; i++)
    for (int j = 0; j < 32; j++)
      if (map[i][j])
        bar(i * 14, j * 14, i * 14 + 14, j * 14 + 14);

  do
  {
    if (kbhit())
    {
      key = getch();
      tx = xp;
      ty = yp;
      switch (key)
      {
        case 80: tx += sin((angle_p - 90) * M_PI / 180) * 32;
                 ty += cos((angle_p - 90) * M_PI / 180) * 32; break;
        case 72: tx -= sin((angle_p - 90) * M_PI / 180) * 32;
                 ty -= cos((angle_p - 90) * M_PI / 180) * 32; break;
        case 77: angle_p += 2; break;
        case 75: angle_p -= 2; break;
      }
      if (!map[int(tx) / 128][int(ty) / 128])
      {
        xp = tx;
        yp = ty;
      }
      cleardevice();

      setcolor(8);
      for (int i = 0; i < 33; i++)
      {
        line(i * 14, 0, i * 14, 448);
        line(0, i * 14, 448, i * 14);
      }

      setfillstyle(1, 7);
      for (int i = 0; i < 32; i++)
        for (int j = 0; j < 32; j++)
          if (map[i][j])
            bar(i * 14, j * 14, i * 14 + 14, j * 14 + 14);
    }

    if (angle_p > 359) angle_p = 0;
    if (angle_p < 0) angle_p = 359;

    for (int i = 0; i < 320; i++)
    {
      angle = (angle_p - 30) * 5.3333333333 + i;
      if (angle < 0) angle = angle + 1920;
      if (angle > 1920) angle -= 1920;
      dist(angle, xp, yp);
    }
  } while (key != 27);

  closegraph();
  return 0;
}
