#include <stdio.h>
#include <fstream.h>
#include <iostream.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "kb.h"

#define ANGLE_0    0
#define ANGLE_90   480
#define ANGLE_180  960
#define ANGLE_270  1440
#define ANGLE_360  1920

void far *data1 = (void far *)new char[16384];
void far *data2 = (void far *)new char[16384];
unsigned char map[32][32];
unsigned char pal[1024];
float tan_table[1920];
float cos_table[320];
float cos__table[1920];
float sin__table[1920];
float y_step[1920];
int tex_off, tex_flag;

ofstream out;
ifstream in;

int dist(int a, unsigned int x_p, unsigned int y_p)
{
  float /*x = x_p, y = y_p,*/ x_dist, y_dist;
  long x, y, inc, c = 0;

/*  if (a == ANGLE_0) a = ANGLE_0 + 1;
  if (a == ANGLE_90) a = ANGLE_90 + 1;
  if (a == ANGLE_180) a = ANGLE_180 + 1;
  if (a == ANGLE_270) a = ANGLE_270 + 1;
  if (a == ANGLE_360) a = ANGLE_270 - 1;*/

  if (a < ANGLE_90 || a >= ANGLE_270)
  {
    x = (x_p / 128) * 128 + 128;
    y = (x_p - x) * tan_table[a] + y_p;
    inc = 128;
  }
  else
  {
    x = (x_p / 128) * 128;
    y = (x_p - x) * tan_table[a] + y_p;
    inc = -128;
    c = -1;
  }
  while ((map[x >> 7 + c][y >> 7] == 0) && (y > 0) && (y < 4096))
  {
    x += inc;
    y -= tan_table[a] * inc;
  }

  x_dist = sqrt(pow(x - x_p, 2) + pow(y - y_p, 2));
//  x_dist = (y - y_p) * sin__table[a];

    tex_off = int(y) % 128;
    tex_flag = 0;
    return x_dist;
}

void fill_tables()
{
  float angle = 0;

  for (int i = 0; i < 1920; i++)
  {
    if (angle != ANGLE_90 && angle != ANGLE_270)
    {
      tan_table[i] = sin(angle * M_PI / 180) / cos(angle * M_PI / 180);
      cos__table[i] = 1 / cos(angle * M_PI / 180);
      y_step[i] = tan_table[i] * 128;
    }
    if (angle != ANGLE_0 && angle != ANGLE_180)
    {
      sin__table[i] = 1 / sin(angle * M_PI / 180);
    }
    angle += 0.1875;
  }

  for (int i = 0; i < 320; i++)
    cos_table[i] = cos((i * 0.1875 - 30) * M_PI / 180);
}

void set_mode(unsigned int mode)
{
  asm
  {
      mov    ax,  mode
      int    10h
  }
}

void set_rgb(unsigned char n, unsigned char r, unsigned char g, unsigned char b)
{
  asm
  {
      mov    dx,  3C8h
      mov    al,  n
      out    dx,  al
      inc    dx
      mov    al,  r
      shr    al,  2
      out    dx,  al
      mov    al,  g
      shr    al,  2
      out    dx,  al
      mov    al,  b
      shr    al,  2
      out    dx,  al
  }
}

void set_pal()
{
  for (int i = 1; i < 256; i++)
    set_rgb(i, pal[i * 4 + 2], pal[i * 4 + 1], pal[i * 4]);
}

void put_line(int x, int from, int to, unsigned char c1, int off, int m)
{
  char c = 128;
  asm
  {
      push   ds
      cmp    tex_flag,   0
      jz     @@4
      lds    si,  data1
      jmp    @@5
@@4:  lds    si,  data2
@@5:  mov    ax,  0A000h
      mov    es,  ax
      mov    di,  x
      mov    cx,  200
@1:   mov    al,  c
      shr    al,  3
      add    al,  c1
      cmp    cx,  from
      jb     @2
      cmp    cx,  to
      ja     @2
      xor    dx,  dx
      mov    ax,  32512
      mov    bx,  m
      div    bx
      mov    bx,  200
      sub    bx,  cx
      cmp    from,  0
      jnz    @@3
      push   cx
      mov    cx,  m
      sub    cx,  200
      shr    cx,  1
      add    bx,  cx
      pop    cx
@@3:  sub    bx,  from
      mul    bx
      shr    ax,  8
      shl    ax,  7
      add    ax,  off
      add    ax,  4
      mov    si,  ax
      mov    al,  ds:[si]
@2:   stosb
      add    di,  319
      cmp    c,   0
      jz     @@7
      dec    c
@@7:  loop   @1
      pop    ds
  }
}

void load()
{
  ifstream in;
  int i = 0, j = 0;
  char c;

  in.open("058-013.bmp");
  in.seekg(54, ios::beg);
  in.read(pal, 1024);
  in.read((unsigned char *)data1, 16384);
  in.close();
  in.open("059-013.bmp");
  in.seekg(1078, ios::beg);
  in.read((unsigned char *)data2, 16384);
  in.close();
  in.open("map.txt");

  do
  {
    in.get(c);
    switch (c)
    {
      case '*': map[i][j] = 1; i++; break;
      case ' ': map[i][j] = 0; i++; break;
      case 10: j++; i = 0;
    }
  }
  while (j < 32);

  in.close();
}

void print_help()
{
  cout << "\n3D World. Version 1.5.\n";
  cout << "Copyright (c) 1999 by MATI Inc.\n\n";
  cout << "\t Usage: 3DWORLD [options <files>]\n\n";
  cout << "Options:\n";
  cout << "\t-r  Record demo to <filename>\n";
  cout << "\t-p  Play demo from <filename>\n";
}

int check_command_line(int argc, char *argv1, char *argv2)
{
  for (int i = 0; i < strlen(argv1); i++)
    argv1[i] = toupper(argv1[i]);
  for (int j = 0; j < strlen(argv2); j++)
    argv2[j] = toupper(argv2[j]);

  if (argc >= 2)
  {
    if (!strcmp(argv1, "-R"))
    {
      out.open(argv2);
      if (!out || argc < 3)
      {
        cout << "Unable to open demo file\n";
        return 1;
      }
    }
    else
    if (!strcmp(argv1, "-P"))
    {
      in.open(argv2);
      if (!in || argc < 3)
      {
        cout << "Unable to open demo file\n";
        return 1;
      }
    }
    else
    if (!strcmp(argv1, "-?"))
    {
      print_help();
      return 2;
    }
    else
    {
      cout << "Unknown command option.\n";
      cout << "Type \"-?\" for help.\n";
      return 1;
    }
  }
  return 0;
}

int main(int argc, char *argv[])
{
  unsigned char key;
  int xp = 2048, yp = 2048, tx, ty;
  int angle_p = 0, angle;
  int color, d, m;
  int l = 0, r = 0, f = 0, b = 0;

  int res = check_command_line(argc, argv[1], argv[2]);
  switch (res)
  {
    case 1: return 1;
    case 2: return 0;
  }
  load();
  set_mode(0x13);
  set_pal();
  fill_tables();

  do
  {
    tx = xp;
    ty = yp;

    key = inportb(0x60);

    switch (key)
    {
      case 80: b = 1; f = 0; break;
      case 72: f = 1; b = 0; break;
      case 77: r = 1; l = 0; break;
      case 75: l = 1; r = 0; break;
      case 208: b = 0; f = 0; break;
      case 200: f = 0; b = 0; break;
      case 205: r = 0; l = 0; break;
      case 203: l = 0; r = 0; break;
    }

    if (b)
    {
      tx += int(sin((angle_p - 90) * M_PI / 180) * 16);
      ty += int(cos((angle_p - 90) * M_PI / 180) * 16);
    }
    if (f)
    {
      tx -= int(sin((angle_p - 90) * M_PI / 180) * 16);
      ty -= int(cos((angle_p - 90) * M_PI / 180) * 16);
    }

    if (r) angle_p += 2;
    if (l) angle_p -= 2;

    xp = tx;
    yp = ty;

    if ((tx % 128 > 64) && map[tx / 128 + 1][ty / 128])
    {
      xp = tx / 128 * 128 + 64;
      tx = xp;
      yp = ty;
    }
    else
    if ((tx % 128 < 64) && map[tx / 128 - 1][ty / 128])
    {
      xp = tx / 128 * 128 + 64;
      tx = xp;
      yp = ty;
    }
    if ((ty % 128 > 64) && map[tx / 128][ty / 128 + 1])
    {
      yp = ty / 128 * 128 + 64;
      ty = yp;
      xp = tx;
    }
    else
    if ((ty % 128 < 64) && map[tx / 128][ty / 128 - 1])
    {
      yp = ty / 128 * 128 + 64;
      ty = yp;
      xp = tx;
    }

    if (angle_p > 359) angle_p = 0;
    if (angle_p < 0) angle_p = 359;

    if (in)
    {
      in >> xp;
      in >> yp;
      in >> angle_p;
      if (!in)
      {
        in.close();
        in.open(argv[2]);
      }
    }

    for (int i = 0; i < 320; i++)
    {
      angle = ((angle_p - 30) * 53 + i * 10) / 10;
      if (angle < 0) angle = angle + 1920;
      if (angle > 1920) angle -= 1920;
      d = dist(angle, xp, yp);
      if (d)
      {
        m = 32768 / (d * cos_table[i]);
        if (m > 200)
          put_line(i, 0, m, 199, tex_off, m);
        else
          put_line(i, 100 - m / 2, 100 + m / 2, 80, tex_off, m);
      }
    }

    K_Reset();

    if (out)
    {
      out << xp << " ";
      out << yp << " ";
      out << angle_p << "\n";
    }

  } while (key != 1);

  set_mode(0x3);
  out.close();
  in.close();
  cout << "Copyright (c) 1999 by MATI Inc.\n";

  return 0;
}
