/****************************************************************************/
/*               祭  祭 祩              */
/*                       ᯮ짮 楫 ᥫ.                       */
/*                       Copyright (c) MATI Inc. 1999                       */
/****************************************************************************/

#include <iostream.h>
#include <fstream.h>
#include <conio.h>
#include <math.h>
#include <time.h>
#include <dos.h>

#define CELL_SIZE     128
#define M             65536L
#define N_DIGIT       23
#define M_DIGIT       16
#define INF           2147483647L
#define MAP_SIZE      12
#define DEMO_SIZE     16
#define STEP_SIZE     8
#define ANGLE_STEP    5

#define ANGLE_INC     0.214285714
#define TABLE_SIZE    1680
#define ANGLE_0       0
#define ANGLE_90      420
#define ANGLE_180     840
#define ANGLE_270     1260
#define ANGLE_360     TABLE_SIZE

long tan_table[TABLE_SIZE];
long ctn_table[TABLE_SIZE];
long sin_table[TABLE_SIZE];
long cos_table[TABLE_SIZE];
int delta[560];

unsigned color_flag;
long dist = INF;

long player_x = 192, player_y = 1344;
int angle = ANGLE_0;
int b = 0, f = 0, r = 0, l = 0, exit_flag = 0;

void interrupt (*old_vec)(...);

char map[MAP_SIZE][MAP_SIZE] =
{{1,1,1,1,1,1,1,1,1,1,1,1},
 {1,0,0,0,0,0,0,0,0,0,0,1},
 {1,0,1,1,0,0,0,0,0,0,0,1},
 {1,0,1,1,1,1,0,0,1,1,1,1},
 {1,0,1,1,0,0,0,0,1,0,0,1},
 {1,0,0,0,0,0,0,0,1,0,0,1},
 {1,0,0,0,0,0,0,0,1,0,0,1},
 {1,1,1,1,0,0,0,0,0,0,0,1},
 {1,0,0,0,0,1,1,0,0,0,0,1},
 {1,0,0,0,0,1,1,0,0,0,0,1},
 {1,0,0,0,0,1,1,0,0,0,0,1},
 {1,1,1,1,1,1,1,1,1,1,1,1}};

void interrupt KB_HANDLER(...)
{
  unsigned char key = inportb(0x60);

  switch (key)
  {
    case  1:  exit_flag = 1; break;
    case 80:  b = 1; f = 0; break;
    case 72:  f = 1; b = 0; break;
    case 77:  r = 1; l = 0; break;
    case 75:  l = 1; r = 0; break;
    case 208: b = 0; break;
    case 200: f = 0; break;
    case 205: r = 0; break;
    case 203: l = 0; break;
  }

  asm mov al, 20h
  asm out 20h, al
}

long Distance(long player_x, long player_y, int angle)
{
  long x = player_x << M_DIGIT, y = player_y << M_DIGIT;
  long xp = x, yp = y, N = 0x800000L;
  long x_dist, y_dist, INC, M_INC, A;
  long MAP_SIZE_N = 0x6000000L;
  unsigned cf1, cf2;

  if (angle < 0) angle = TABLE_SIZE - 1 - (-angle) % TABLE_SIZE;
  if (angle > TABLE_SIZE - 1) angle %= TABLE_SIZE;

  if ((angle != ANGLE_0) && (angle != ANGLE_180))
  {
    if ((angle > ANGLE_0) && (angle < ANGLE_180))
    {
      yp = y % N;
      xp += (yp >> M_DIGIT) * ctn_table[angle];
      yp = y - yp;
      INC = -N;
      A = -1;
      cf1 = 0;
    }
    else
    {
      yp = N - (y % N);
      xp -= (yp >> M_DIGIT) * ctn_table[angle];
      yp += y;
      INC = N;
      A = 0;
      cf1 = 1;
    }

    M_INC = INC >> M_DIGIT;
    while(!map[int((yp >> N_DIGIT) + A)][int(xp >> N_DIGIT)] && (xp > 0) && (xp < MAP_SIZE_N))
    {
      yp += INC;
      xp -= M_INC * ctn_table[angle];
    }

    if (!cos_table[angle])
      x_dist = (yp - y) >> M_DIGIT;
    else
      x_dist = (xp - x) / cos_table[angle];
    if (x_dist < 0) x_dist = -x_dist;
  }
  else
    x_dist = INF;

  xp = x, yp = y;

  if ((angle != ANGLE_90) && (angle != ANGLE_270))
  {
    if ((angle > ANGLE_90) && (angle < ANGLE_270))
    {
      xp = x % N;
      yp += (xp >> M_DIGIT) * tan_table[angle];
      xp = x - xp;
      INC = -N;
      A = -1;
      cf2 = 0;
    }
    else
    {
      xp = N - (x % N);
      yp -= (xp >> M_DIGIT) * tan_table[angle];
      xp += x;
      INC = N;
      A = 0;
      cf2 = 1;
    }

    M_INC = INC >> M_DIGIT;
    while(!map[int(yp >> N_DIGIT)][int((xp >> N_DIGIT) + A)] && (yp > 0) && (yp < MAP_SIZE_N))
    {
      xp += INC;
      yp -= M_INC * tan_table[angle];
    }

    if (!sin_table[angle])
      y_dist = (xp - x) >> M_DIGIT;
    else
      y_dist = (yp - y) / sin_table[angle];
    if (y_dist < 0) y_dist = -y_dist;
  }
  else
    y_dist = INF;

  if (y_dist < x_dist)
  {
    color_flag = cf2 + 2;
    return y_dist;
  }
  else if (x_dist < y_dist)
  {
    color_flag = cf1;
    return x_dist;
  }

  return dist;
}

void BuildTables()
{
  int i;

  for (i = 0; i < TABLE_SIZE; i++)
  {
    sin_table[i] = (long)(M * sin(i * ANGLE_INC * M_PI / 180));
    cos_table[i] = (long)(M * cos(i * ANGLE_INC * M_PI / 180));
    if (cos_table[i])
      tan_table[i] = (long)(M * tan(i * ANGLE_INC * M_PI / 180));
    else
      tan_table[i] = INF;
    if (sin_table[i])
      ctn_table[i] = (long)(M / tan(i * ANGLE_INC * M_PI / 180));
    else
      ctn_table[i] = INF;
  }

  for (i = 0; i < 560; i++)
    delta[i] = 0;
}

void set_text_mode()
{
  asm    mov    ax,  3
  asm    int    10h
}

void set_graph_mode()
{
  asm    mov    ax,  13h
  asm    int    10h
  asm    mov    dx,  3C4h
  asm    mov    al,  4
  asm    out    dx,  al
  asm    inc    dx
  asm    in     al,  dx
  asm    or     al,  4
  asm    and    al,  0F7h
  asm    out    dx,  al
  asm    mov    dx,  3D4h
  asm    mov    al,  14h
  asm    out    dx,  al
  asm    inc    dx
  asm    in     al,  dx
  asm    and    al,  0BFh
  asm    out    dx,  al
  asm    dec    dx
  asm    mov    al,  17h
  asm    out    dx,  al
  asm    inc    dx
  asm    in     al,  dx
  asm    or     al,  40h
  asm    out    dx,  al
  asm    push   0A000h
  asm    pop    es
  asm    xor    di,  di
  asm    xor    ax,  ax
  asm    mov    cx,  8000h
  asm    cld
  asm    rep    stosw
}

void put_line(int x, int delta, int from, int to, unsigned char c, unsigned page)
{
  asm    push   0A000h
  asm    pop    es
  asm    mov    cx,  x
  asm    mov    dx,  3C4h
  asm    mov    ax,  0102h
  asm    and    cl,  3
  asm    shl    ah,  cl
  asm    out    dx,  ax
  asm    mov    di,  x
  asm    shr    di,  2
  asm    add    di,  page
  asm    add    di,  1600
  asm    mov    dx,  delta
  asm    mov    ax,  from
  asm    sub    ax,  dx
  asm    jns    lab7
  asm    mov    dx,  from
lab7:
  asm    mov    ax,  dx
  asm    mov    bx,  ax
  asm    shl    ax,  6
  asm    shl    bx,  4
  asm    add    di,  ax
  asm    add    di,  bx
  asm    cmp    from,  0
  asm    jz     lab2
  asm    mov    cx,  from
  asm    sub    cx,  dx
  asm    jz     lab2
  asm    mov    al,  191
  asm    sub    al,  dl
  asm    cmp    al,  128
  asm    jae    lab1
  asm    xor    al,  al
lab1:
  asm    stosb
  asm    cmp    al,  128
  asm    jbe    lab6
  asm    dec    al
lab6:
  asm    add    di,  79
  asm    loop   lab1
lab2:
  asm    mov    al,  c
  asm    mov    cx,  to
  asm    sub    cx,  from
lab3:
  asm    stosb
  asm    add    di,  79
  asm    loop   lab3
  asm    cmp    from,  0
  asm    jz     lab5
  asm    xor    al,  al
  asm    mov    cx,  from
  asm    sub    cl,  dl
  asm    jz     lab5
lab4:
  asm    stosb
  asm    add    di,  79
  asm    loop   lab4
lab5:
}

void set_rgb(char n, char r, char g, char b)
{
  asm    mov    dx,  3C8h
  asm    mov    al,  n
  asm    out    dx,  al
  asm    inc    dx
  asm    mov    al,  r
  asm    out    dx,  al
  asm    mov    al,  g
  asm    out    dx,  al
  asm    mov    al,  b
  asm    out    dx,  al
}

void set_page(int page)
{
  asm    xor    bl,  bl
  asm    cmp    page,0
  asm    jz     lab1
  asm    mov    bl,  40h
lab1:
  asm    mov    dx,  3D4h
  asm    mov    al,  0Ch
  asm    mov    ah,  bl
  asm    out    dx,  ax
  asm    mov    al,  0Dh
  asm    xor    ah,  ah
  asm    out    dx,  ax
}

void vert_ret()
{
  asm    cli
  asm    mov    dx,  03DAh
lab1:
  asm    in     al,  dx
  asm    test   al,  8
  asm    jz     lab1
lab2:
  asm    in     al,  dx
  asm    test   al,  8
  asm    jnz    lab2
  asm    sti
}

int sign_func(int arg)
{
  if (arg < 0) return -1;
  if (arg > 0) return 1;

  return 0;
}

void main()
{
  long m;
  int page = 0, i, k;
  unsigned long frames = 0, t;
  unsigned color;

  BuildTables();
  set_graph_mode();

  old_vec = getvect(0x09);
  setvect(0x09, KB_HANDLER);

  for (i = 0; i < 64; i++)
  {
    set_rgb(i, 0, 0, i);
    set_rgb(i + 64, 0, i, 0);
    set_rgb(i + 128, i, 0, 0);
    set_rgb(i + 192, i, i, i);
  }

  t = clock();

  do
  {
//    vert_ret();

    if (b)
    {
      player_x += int(sin(((float)angle / 4.66666 - 90) * M_PI / 180) * STEP_SIZE);
      player_y += int(cos(((float)angle / 4.66666  - 90) * M_PI / 180) * STEP_SIZE);
    }
    else
    if (f)
    {
      player_x -= int(sin(((float)angle / 4.66666 - 90) * M_PI / 180) * STEP_SIZE);
      player_y -= int(cos(((float)angle / 4.66666  - 90) * M_PI / 180) * STEP_SIZE);
    }

    if (l) angle += ANGLE_STEP;
    if (r) angle -= ANGLE_STEP;
    if (angle > TABLE_SIZE - 1) angle -= TABLE_SIZE;
    if (angle < 0) angle += TABLE_SIZE;

    set_page(page ^ 1);
    for (i = 0; i < 280; i++)
    {
      dist = Distance(player_x, player_y, angle + 160 - i);
      if (dist)
      {
        k = TABLE_SIZE - 160 + i;
        asm mov ax, 1234
        m = 16384 / ((dist * cos_table[k % TABLE_SIZE]) >> M_DIGIT);
        color = 63 - int(dist >> 4);
        if (color > 63) color = 0;
        color += color_flag << 6;
        if (m > 79)
        {
          put_line(i + 20, delta[i + page * 280], 0, 159, color, page * 0x4000);
          delta[i + page * 280] = 0;
        }
        else
        {
          put_line(i + 20, delta[i + page * 280], 80 - int(m), 80 + int(m), color, page * 0x4000);
          delta[i + page * 280] = 80 - int(m);
        }
      }
    }
    page ^= 1;
    frames++;

    if (angle < 0) angle = TABLE_SIZE - (-angle) % TABLE_SIZE;
    if (angle > TABLE_SIZE - 1) angle %= TABLE_SIZE;

  } while (!exit_flag);

  setvect(0x09, old_vec);

  set_text_mode();
  cout << "Copyright (c) MATI Inc. 1999\n";

  t = clock() - t;
  cout << (double)frames * CLK_TCK / t << " FPS\n";
  cout << frames << " frames, " << (double)t / CLK_TCK << " seconds\n";
}
