#include <fstream.h>
#include <stdlib.h>
#include <conio.h>

unsigned char *data = new char[16384];
unsigned char palette[1024];

void Load(char *filename)
{
  ifstream in(filename, ios::binary);
  if (!in)
  {
    cout << "Unable to open file \n";
    exit(1);
  }

  in.seekg(54, ios::beg);
  in.read(palette, 1024);
  in.read(data, 16384);

  in.close();
}

void set_text_mode()
{
  asm
  {
      mov    ax,  3
      int    10h
  }
}

void set_graph_mode()
{
  asm
  {
      mov    ax,  13h
      int    10h
      mov    dx,  3C4h
      mov    al,  4
      out    dx,  al
      inc    dx
      in     al,  dx
      or     al,  4
      and    al,  0F7h
      out    dx,  al
      mov    dx,  3D4h
      mov    al,  14h
      out    dx,  al
      inc    dx
      in     al,  dx
      and    al,  0BFh
      out    dx,  al
      dec    dx
      mov    al,  17h
      out    dx,  al
      inc    dx
      in     al,  dx
      or     al,  40h
      out    dx,  al
      push   0A000h
      pop    es
      xor    di,  di
      xor    ax,  ax
      mov    cx,  8000h
      cld
      rep    stosw
  }
}

void set_rgb(char n, char r, char g, char b)
{
  asm
  {
      mov    dx,  3C8h
      mov    al,  n
      out    dx,  al
      inc    dx
      mov    al,  r
      out    dx,  al
      mov    al,  g
      out    dx,  al
      mov    al,  b
      out    dx,  al
  }
}

void SetPalette()
{
  for (int i = 1; i < 256; i++)
    set_rgb(i, palette[i * 4 + 2] / 4, palette[i * 4 + 1] / 4, palette[i * 4] / 4);
}

void PutImage(int x, int y, void far *pic)
{
  asm
  {
      push   ds
      push   0A000h
      pop    es
      mov    di,  y
      mov    ax,  di
      shl    di,  8
      shl    ax,  6
      add    di,  ax
      add    di,  x
      shr    di,  2
      lds    si,  pic
      mov    cx,  128
@@1:  push   cx
      mov    cx,  128
@@2:  push   cx
      mov    ch,  128
      sub    ch,  cl
      mov    cl,  ch
      xor    ch,  ch
      mov    dx,  3C4h
      mov    al,  2
      and    cl,  3
      mov    ah,  1
      shl    ah,  cl
      out    dx,  ax
      movsb
      dec    di
      cmp    cl,  3
      jne    @@3
      inc    di
@@3:  pop    cx
      loop   @@2
      sub    di,  32
      add    di,  80
      pop    cx
      loop   @@1
      pop    ds
  }
}

void SetAddr(unsigned addr)
{
  asm
  {
      mov    bx,  addr
      mov    dx,  3D4h
      mov    al,  0Ch
      mov    ah,  bh
      out    dx,  ax
      mov    al,  0Dh
      mov    ah,  bl
      out    dx,  ax
  }
}

void main()
{
  Load("059-013.bmp");
  set_graph_mode();
  SetPalette();
  PutImage(160 - 64, 100 - 64, (void far *)data);
  getch();
  SetAddr(1);
  getch();
  set_text_mode();
}
